using System;

namespace Plazma
{
	class Program
	{
		public static void Main(string[] args)
		{
			string s=Console.ReadLine();
			int n=int.Parse(s.Split()[0]);
			int Q=int.Parse(s.Split()[1]);
			
			int[] d=new int[n];
			int[] p=new int[n];
			double[] k=new double[Q];
			
			
			for(int i=0;i<n;i++)
			{
				s=Console.ReadLine();
				d[i]=int.Parse(s.Split()[0]);
				p[i]=int.Parse(s.Split()[1]);
			}
			
			for(int j=0;j<Q;j++)
			{
				k[j]=double.Parse(Console.ReadLine());
			}
			
			
			for(int i=0;i<Q;i++)
			{
				double pp=0;
				double kp=0;
				int b=0;
				
				for(double j=0;j<=k[i];j++)
				{
					if(d[b]==j)
					{
						kp+=p[b];
						if(b!=n-1)
							b++;
						else
						{
							if(kp>(k[i]-j+1))
				   			{
							   	pp+=k[i]-j+1;
							   	break;
							}
							else
							{
								pp+=kp;
								break;
							}
						}
					}
					
					if(kp>0)
					{
						pp=pp+1;
						kp=kp-1;
					}
				}
				
				Console.WriteLine(pp);
			}
			
			
		}
	}
}